# coding: utf-8

"""
    DataCore API  - Sport

    For more details, see openapi/init.py

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the file manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from pydantic import BaseModel, Field, StrictStr, constr


class LeagueExternalIdsPostBody(BaseModel):
    """
    LeagueExternalIdsPostBody
    """

    league_external_id: Optional[StrictStr] = Field(
        None, alias="leagueExternalId", description="The unique identifier of the external ids"
    )
    league_id: Optional[StrictStr] = Field(None, alias="leagueId", description="The unique identifier of the league")
    source: constr(strict=True, max_length=100) = Field(..., description="The source of the external Id")
    source_type: StrictStr = Field(..., alias="sourceType", description="Source type of external Id")
    source_external_id: constr(strict=True, max_length=100) = Field(
        ..., alias="sourceExternalId", description="Identifier of external source"
    )
    __properties = ["leagueExternalId", "leagueId", "source", "sourceType", "sourceExternalId"]

    class Config:
        """Pydantic configuration"""

        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LeagueExternalIdsPostBody:
        """Create an instance of LeagueExternalIdsPostBody from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LeagueExternalIdsPostBody:
        """Create an instance of LeagueExternalIdsPostBody from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LeagueExternalIdsPostBody.parse_obj(obj)

        _obj = LeagueExternalIdsPostBody.parse_obj(
            {
                "league_external_id": obj.get("leagueExternalId"),
                "league_id": obj.get("leagueId"),
                "source": obj.get("source"),
                "source_type": obj.get("sourceType"),
                "source_external_id": obj.get("sourceExternalId"),
            }
        )
        return _obj
